//
// SVG 쓮eXg
//
#include <windows.h>
#include <atlbase.h>
CComModule _Module;
#include <atlwin.h>
#include <atlwin.h>
#include <atlcom.h>
#include <atlhost.h>

static HRESULT invoke(IDispatch *idispatch, int type, const char *name, VARIANTARG args[]=NULL, int nargs=0, VARIANT *result = NULL, DISPID params[] = NULL, int nparams = 0)
{
	USES_CONVERSION;
	
	OLECHAR* method = A2OLE(name);
	DISPID id;
	HRESULT hr;
	if (SUCCEEDED(hr = idispatch->GetIDsOfNames(IID_NULL, &method, 1, GetUserDefaultLCID(), &id))) {
		DISPPARAMS param =  {args, params, nargs, nparams};
		if (result) {
			VariantInit(result);
		}
		hr = idispatch->Invoke(id, IID_IDispatch, GetUserDefaultLCID(), type, &param, result, NULL, NULL);
	}
	return hr;
}

static HRESULT method(IDispatch *idispatch, const char *method, VARIANTARG args[], int narg, VARIANT *result)
{
	return invoke(idispatch, DISPATCH_METHOD, method, args, narg, result);
}

static HRESULT getProperty(IDispatch *idispatch, const char *name, VARIANT *result)
{
	return invoke(idispatch, DISPATCH_PROPERTYGET, name, NULL, 0, result);
}

static HRESULT putProperty(IDispatch *idispatch, const char *name, VARIANT *var)
{
	DISPID putProp = DISPID_PROPERTYPUT;
	return invoke(idispatch,
				  (var->vt == VT_UNKNOWN || var->vt == VT_DISPATCH || (var->vt & VT_ARRAY) || (var->vt & VT_BYREF)) ? DISPATCH_PROPERTYPUTREF : DISPATCH_PROPERTYPUT,
				  name, var, 1, NULL, &putProp, 1);
}

#import "c:\WINDOWS\system32\Adobe\SVG Viewer 3.0\NPSVG3.dll" rename_namespace("SVG") named_guids

class CSVGWindow : public CWindowImpl<CSVGWindow, CAxWindow>
{
public:
	CComPtr<SVG::ISVGControl> svg;

	HRESULT init() {
		HRESULT hr;
		if (SUCCEEDED(hr = CreateControl(OLESTR("Adobe.SVGCtl.3")))) {
			hr = QueryControl(&svg);
		}
		return hr;
	}

	LRESULT OnDestroy(UINT, WPARAM, LPARAM, BOOL&){
		if (svg) {
			svg.Release();
			svg.Detach();
		}
		// AvP[VI XXX
		PostQuitMessage(0);
		return S_OK;
	}

	~CSVGWindow() {
		if (svg) {
			svg.Release();
			svg.Detach();
		}
	}

	BEGIN_MSG_MAP(CSVGWindow)
        MESSAGE_HANDLER(WM_DESTROY,  OnDestroy)
	END_MSG_MAP()
};

int APIENTRY WinMain(HINSTANCE hInstance,
					 HINSTANCE hPrevInstance,
					 LPSTR     lpCmdLine,
					 int       nCmdShow)
{
	int ret;

	_Module.Init(NULL, hInstance);
	AtlAxWinInit();
	
	CSVGWindow wnd;
	wnd.Create(NULL, CWindow::rcDefault, NULL, WS_OVERLAPPEDWINDOW);
	if (SUCCEEDED(wnd.init())) {

		//IDispatch *doc = wnd.svg->getSVGDocument();
		wnd.svg->PutSRC(OLESTR("http://www.denpa.org/~go/test.svg"));
		//wnd.svg->PutSRC(OLESTR("file://cygwin/home/go/test.svg"));
		wnd.ShowWindow(TRUE);

		{
			USES_CONVERSION;
			CComPtr<IDispatch>doc;
			wnd.svg->raw_getSVGDocument(&doc);
			if (doc) {
				{
					VARIANT result;
					VariantInit(&result);
					getProperty(doc, "URL", &result);
					if (result.vt == VT_BSTR) {
						TCHAR *str = OLE2T(result.bstrVal);
						MessageBox(wnd, str, TEXT("Error"), MB_OK);
					}
				}
			}
		}

		// ł킯 doc ƂȂȂƋ̂܂
		
		{
			USES_CONVERSION;
			CComPtr<IDispatch>doc;
			wnd.svg->raw_getSVGDocument(&doc);
			if (doc) {
				VARIANT root;
				VariantInit(&root);
				method(doc, "getRootElement", NULL, 0, &root);
				if (root.vt == VT_DISPATCH && root.pdispVal) {
					MessageBox(wnd, TEXT("success to get rootElement"), TEXT("Error"), MB_OK);

					{
						VARIANT test;
						VariantInit(&test);
						VARIANT arg;
						V_VT(&arg) = VT_BSTR;
						V_BSTR(&arg) = A2OLE("width");
						method(root.pdispVal, "getAttribute", &arg, 1, &test);
						method(root.pdispVal, "getAttribute", &arg, 1, &test);
					}

					{
						VARIANT elem;
						VariantInit(&elem);
						VARIANT arg;
						V_VT(&arg) = VT_BSTR;
						V_BSTR(&arg) = A2OLE("hoge");
						method(root.pdispVal, "getElementById", &arg, 1, &elem);
						if (elem.vt == VT_DISPATCH && elem.pdispVal) {
							
							{
								VARIANT test;
								VariantInit(&test);

								// XXX getAttribute ͓Ă͗l
								V_VT(&arg) = VT_BSTR;
								V_BSTR(&arg) = A2OLE("style");
								method(elem.pdispVal, "getAttribute", &arg, 1, &test);

								// setAttribute Ă݂Ăiep^[) Ȃ񂩂Ȃc
								// Ȃɂʂɂ̂H
#if 1
								VARIANT style[2];
								V_VT(style) = VT_BSTR;
								V_BSTR(style) = SysAllocString(A2OLE("fill"));
								V_VT(style+1) = VT_BSTR;
								V_BSTR(style+1) = SysAllocString(A2OLE("red"));
								method(elem.pdispVal, "setAttribute", style, 2, &test);
								SysFreeString(style[0].bstrVal);
								SysFreeString(style[0].bstrVal);
#else
								VARIANT style[2];
								V_VT(style) = VT_BSTR;
								V_BSTR(style) = SysAllocString(A2OLE("style"));
								V_VT(style+1) = VT_BSTR;
								V_BSTR(style+1) = SysAllocString(A2OLE("fill:red;"));
								method(elem.pdispVal, "setAttribute", style, 2, &test);
								SysFreeString(style[0].bstrVal);
								SysFreeString(style[0].bstrVal);
#endif
								
								V_VT(&arg) = VT_BSTR;
								V_BSTR(&arg) = A2OLE("style");
								method(elem.pdispVal, "getAttribute", &arg, 1, &test);
								method(elem.pdispVal, "getAttribute", &arg, 1, &test);
							}
						}
					}						
				}
			}
		}
		
		MSG msg;
		while (GetMessage(&msg, NULL, 0, 0)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		ret = msg.wParam;
	} else {
		MessageBox(wnd, TEXT("Failed to load SVG"), TEXT("Error"), MB_OK);
		ret = 1;
	}

	_Module.Term();
	return ret;
}
